//*CMZ :  1.03/09 06/12/97  16.48.24  by  Fons Rademakers
//*-- Author :    Rene Brun   04/01/95

//*KEEP,CopyRight,T=C.
/*************************************************************************
 * Copyright(c) 1995-1998, The ROOT System, All rights reserved.         *
 * Authors: Rene Brun, Nenad Buncic, Valery Fine, Fons Rademakers.       *
 *                                                                       *
 * Permission to use, copy, modify and distribute this software and its  *
 * documentation for non-commercial purposes is hereby granted without   *
 * fee, provided that the above copyright notice appears in all copies   *
 * and that both the copyright notice and this permission notice appear  *
 * in the supporting documentation. The authors make no claims about the *
 * suitability of this software for any purpose.                         *
 * It is provided "as is" without express or implied warranty.           *
 *************************************************************************/
//*KEND.

//*KEEP,Strlen.
#include "Strlen.h"
//*KEEP,TStyle.
#include "TStyle.h"
//*KEEP,TAttFunc.
#include "TAttFunc.h"
//*KEND.

ClassImp(TAttFunc)

//______________________________________________________________________________
//
//  Manages Functions attributes. Referenced by TStyle.
//

//______________________________________________________________________________
TAttFunc::TAttFunc()
{
   if (!gStyle) return;
   fFuncColor = gStyle->GetFuncColor();
   fFuncWidth = gStyle->GetFuncWidth();
   fFuncStyle = gStyle->GetFuncStyle();
}

//______________________________________________________________________________
TAttFunc::TAttFunc(Color_t color, Style_t style, Width_t width)
{
   fFuncColor = color;
   fFuncWidth = width;
   fFuncStyle = style;
}

//______________________________________________________________________________
TAttFunc::~TAttFunc()
{
}

//______________________________________________________________________________
void TAttFunc::Copy(TAttFunc &attfunc)
{
   attfunc.fFuncColor  = fFuncColor;
   attfunc.fFuncStyle  = fFuncStyle;
   attfunc.fFuncWidth  = fFuncWidth;
}

//______________________________________________________________________________
void TAttFunc::Reset(Option_t *)
{
   fFuncColor  = 1;
   fFuncStyle  = 1;
   fFuncWidth  = 1;
}
